<!doctype html>
<html lang="en">
<head>
    <title>Dark Mode GPU PDFs with MuPDF</title>
    <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate"/>
  <link rel="shortcut icon" href="/assets/img/logo.png" type="image/png">
  <meta http-equiv="Pragma" content="no-cache"/>
  <meta http-equiv="Expires" content="0"/>
  <!-- link rel="shortcut icon" href="/assets/img/logo.png" type="image/png"-->
  <link rel="stylesheet" href="/assets/styles.css">
</head>
<body>
<header class=nav-bar>
  <nav>
    <div class=sidebar-button></div>
    <!--div id=bwtoggle></div-->
    <a class="homelink spy" href="/">r<span class=hideable>wx.gg</span></a>
    <div class="nav-right">
      <!-- div id=search-box></div -->
      <ul class=nav-links>
        <li class=nav-item><a class=nav-link href="/boost/">Boosts</a></li>
        <!--
        <li class=nav-item><a class=nav-link href="/how/">HowTos</a></li>
        <li class=nav-item><a class=nav-link href="/contrib/">Contribute</a></li>
        -->
        <li class=nav-item><a class="nav-link" href="https://gitlab.com/rwx.gg/README">GitLab</a></li>
        <li class=nav-item><a class="nav-link" href="https://www.youtube.com/rwxrob">YouTube</a></li>
        <li class=nav-item><a class="nav-link" href="https://discord.gg/9wydZXY">Discord</a></li>
        <li class=nav-item><a class="nav-link" href="https://twitch.tv/rwxrob">Twitch</a></li>
      </ul>
    </div>
  </nav>
</header>
<main id=top>
<div class=container>  <h1 id=title class=duck><a href="https://duckduckgo.com/lite?kae=t&q=Dark Mode GPU PDFs with MuPDF">Dark Mode GPU PDFs with MuPDF</a></h1>
  <h2 id=subtitle>A Fast and Safe Viewer with Vim Mode</h2>
  <p>The <em>MuPDF</em> viewer it wicked fast on all fronts, supports dark mode (inversion), and has <a href="/tools/editors/vi/">Vi</a> bindings built in. However, it is maintained by Artifex, not hosted on GitHub or GitLab, and has ancient versions in most Debian-based distros.</p>
  <div class="co-tip">
  <p>Only the latest has a working <code>-I</code> inverted dark mode. It’s worth the time to compile it and compiling will be a good learning activity.</p>
  </div>
  <h2 id="building-from-source">Building from Source</h2>
  <p>First get all the dependencies. You should be doing this from a device that has a graphics driver supporting OpenGL, which you probably do.</p>
  <pre class="sh"><code>sudo apt install -y xorg-dev freeglut3-dev</code></pre>
  <pre class="out"><code>Reading package lists... Done
  Building dependency tree
  Reading state information... Done
  The following NEW packages will be installed:
    freeglut3-dev xorg-dev
  0 upgraded, 2 newly installed, 0 to remove and 146 not upgraded.
  Need to get 128 kB of archives.
  After this operation, 812 kB of additional disk space will be used.
  Get:1 http://archive.ubuntu.com/ubuntu bionic/universe amd64 freeglut3-dev amd64 2.8.1-3 [124 kB]
  Get:2 http://archive.ubuntu.com/ubuntu bionic-updates/main amd64 xorg-dev all 1:7.7+19ubuntu7.1 [4,300 B]
  Fetched 128 kB in 1s (171 kB/s)
  Selecting previously unselected package freeglut3-dev:amd64.
  (Reading database ... 326158 files and directories currently installed.)
  Preparing to unpack .../freeglut3-dev_2.8.1-3_amd64.deb ...
  Unpacking freeglut3-dev:amd64 (2.8.1-3) ...
  Selecting previously unselected package xorg-dev.
  Preparing to unpack .../xorg-dev_1%3a7.7+19ubuntu7.1_all.deb ...
  Unpacking xorg-dev (1:7.7+19ubuntu7.1) ...
  Setting up xorg-dev (1:7.7+19ubuntu7.1) ...
  Setting up freeglut3-dev:amd64 (2.8.1-3) ...</code></pre>
  <p>Now you have to get the code.</p>
  <div class="co-stop">
  <p>If you haven’t already done so <a href="/services/gitlab/repos/">setup your local repos</a>.</p>
  </div>
  <p>Then create a directory to contain the <code>mupdf</code> repo.</p>
  <pre class="sh"><code>cd ~/repos
  mkdir git.ghostscript.com
  cd git.ghostscript.com</code></pre>
  <p>Now to a <em>recursive</em> clone to not only get the Git repo but also all the <em>submodule</em> repos within it.</p>
  <pre class="sh"><code>git clone --recursive git://git.ghostscript.com/mupdf</code></pre>
  <p>This will have a <em>lot</em> of output.</p>
  <p>Change into the new <code>mupdf</code> directory and then force the submodules to update as well (if they didn’t already).</p>
  <pre class="sh"><code>cd mupdf
  git submodule update --init </code></pre>
  <p>Again a lot more output.</p>
  <p>Now you just need to build it. You can either make and install it for the whole computer and all users on it, or you can make a local copy. Just change the <code>prefix</code> to whatever you would like. Keep in mind that installing it for the system requires <code>sudo</code>, which is what this example shows.</p>
  <div class="co-fyi">
  <p>The <a href="/tools/linux/lfh/">LFH</a> calls for putting all installed user applications into <code>/usr/local</code>.</p>
  </div>
  <pre class="sh"><code>sudo make prefix=/usr/local install`</code></pre>
  <p>This will produce a <em>massive</em> amount of output and often pause and possibly look like it is failing even though it is not. Just be patient. You are compiling a rather large application written in C and C++ from scratch. Take a moment to be thankful for precompiled binary packages for most things.</p>
  <p>When the compilation finishes you will see two new binaries in <code>/usr/local</code>: <code>mupdf-gl</code> and <code>mupdf-xl</code>. You can either use them this way or create an alias, functions, or small script to call them.</p>
  <p>For example, to use the fast <code>mupdf-gl</code> with inversion on every time you type <code>mupdf</code> try adding the following alias to your Bash configuration.</p>
  <pre class="sh"><code>alias mupdf=&#39;mupdf-gl -I&#39;</code></pre>
  <p>Perhaps you want to consolidate all your PDFs into a common <code>PDFDIR</code> that keeps them organized.</p>
  <p>First create the directory or project repo. Then export the <code>PDFDIR</code> in your Bash configuration something like this.</p>
  <pre class="sh"><code>export PDFDIR=$HOME/repos/gitlab.com/rwxyou/pdfs</code></pre>
  <p>Now you can create a script like the following and put it in your <code>dotfiles/scripts</code> directory or someplace else in your <code>PATH</code>.</p>
  <pre class="sh"><code>cd ~/repos/gitlab.com/rwxyou/dotfiles/scripts
  touch pdf</code></pre>
  <p>Here’s one example, tweak it as you like.</p>
  <pre class="sh"><code>#!/bin/sh

  if [ -z &quot;$PDFDIR&quot; ];then
    warn &#39;The `PDFDIR` env var not set.&#39;
    exit 0
  fi

  list () {
    find &quot;$PDFDIR&quot; -name &quot;*.pdf&quot; -exec basename {} \;
  }

  usage () {
    usageln &#39;list|usage|&lt;pdf&gt;&#39;
  }

  if [ -n &quot;$COMP_LINE&quot; ]; then
    prefix=$(echo &quot;$COMP_LINE&quot; | cut -d &quot; &quot; -f 2)
    list | grep ^$prefix
    exit 0
  fi

  case &quot;$1&quot; in
    list) list; exit ;;
    usage) usage; exit ;;
  esac

  # actually we have a pdf name, not a command
  # if gotten this far
  pdfpath=&quot;$PDFDIR/$1&quot;

  # always open using GL in dark (inverted) mode
  if [ -r &quot;$pdfpath&quot; ];then
    mupdf-gl -I &quot;$pdfpath&quot;  &amp;&gt;/dev/null &amp;
  fi</code></pre>
</main>
<footer>
  <p><a href="/copyright/" id=copyright>© 2020 Rob Muhlestein. Licensed under Creative Commons Attribution-ShareAlike.</a><br/>Does something seem to have changed? <a href="/changes/">Check the change log</a>.
  <br>See something wrong? <a class="nodecor" href="https://gitlab.com/rwx.gg/README/-/issues">Open a ticket</a>.
  </p>
</footer>
<script src="/assets/main.js"></script>
</body>
</html>